package reflect;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

public class ShapeFactory {
	public static void main(String[] args) {
		String className = "reflect.Square";
		try {
			Shape shape1 = makeShape(className, 32.0);
			System.out.println(shape1);
			//Shape shape2 = makeShape(className, null);
			//System.out.println(shape2);
		} catch (ClassNotFoundException | InstantiationException | IllegalAccessException | IllegalArgumentException
				| InvocationTargetException e) {
			System.out.println("创建失败");
			e.printStackTrace();
		}
	}

	/* 局限性较大，只适用于类仅有一个构造函数的情况 */
	public static Shape makeShape(String shapeType, Object... args) throws ClassNotFoundException,
			InstantiationException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
		
		/*该段代码仅用于演示：输出shapeType所代表类型的所有构造函数信息*/
		Class shapeClass = Class.forName(shapeType);
		Constructor[] constructors = shapeClass.getDeclaredConstructors();

		for (Constructor e : constructors) {
			System.out.print(e.getName() + "    ");
			Class[] paramTypes = e.getParameterTypes();
			for (Class e1 : paramTypes)
				System.out.print(e1.getName() + " ");
			System.out.println();
		}
		/*这里才是根据参数*/
		return (Shape) constructors[0].newInstance(args);

	}

}
