package reflect;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import org.junit.Before;
import org.junit.Test;

/*需要先导入junit4*/
public class UserReflectTest {

	private Map<String, String> confMap = new HashMap<String, String>(); 
	private String fileName = "conf/User.conf";
	Properties prop;
	
	@Before
	public void init() {
		/*这段代码也可
		try(Scanner sc = new Scanner(new File("conf/User.conf"))){
			while(sc.hasNextLine()){
				String line = sc.nextLine();
				String[] result = line.split(" ");
				confMap.put(result[0], result[1]);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}*/
		
		prop = new Properties();
		
		try(InputStreamReader isr = new InputStreamReader(new FileInputStream(fileName))){
			prop.load(isr);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	@Test
	public void test(){
		
		String className = prop.getProperty("className");
		String id = prop.getProperty("id");
		String userName = prop.getProperty("userName");
		String password = prop.getProperty("password");
		
		String idProp = "id";
		String userNameProp = "userName";
		String passwordProp = "password";
		
		
		try{
			//1.获取构造函数并新建对象
			Class<?> clazz = Class.forName(className);
			//Class<?> clazz = Class.forName("reflect.User");
			Constructor<?> constructor = clazz.getConstructor((Class[])null);
			User user = (User)constructor.newInstance();
			System.out.println(user.getId());
			
			//2.获取对象的setId方法并调用
			Method setId = clazz.getMethod("setId" ,Integer.class);
			System.out.println(setId.getName());
			setId.invoke(user, Integer.valueOf(id).intValue());
			System.out.println(user.getId());
			
			//3.获取对象的getId方法并调用
			Method getId = clazz.getMethod("getId");
			System.out.println(getId.getName());
			System.out.println(getId.invoke(user));
			
			//4.直接操作User对象的属性
			//Field field = clazz.getField("userName");
			System.out.println(clazz.getName());
			Field[] fields = clazz.getDeclaredFields();
			System.out.println(fields.length);
			for (int i = 0; i < fields.length; i++) {
				System.out.println(fields[i]);
			}
			Field field = clazz.getDeclaredField(idProp);
			field.setAccessible(true);
			field.set(user,1);
			System.out.println(field.get(user));
			
			
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
	}

}
